/*
 Copyright (C) 1997, Slava Ilyin
*/
#include "out_ext.h"
#include"menu.h"
#include"runbas.h"
#include"rw_sess.h"
#include "crt_util.h" 
#include"batch.h"

struct 
{
   double pmin, pmax;
   long nsize, numpar, ncall1,ncall2,  it1, it2;
} batch_1 = {0,100,0,0,10000,10000,5,5};
            
/* ******************************************* */
/*     Add session in batch                 * */
/* ******************************************* */
/* Subroutine */ int b_add__(void)
{
int mode;

void * pscr=NULL;

int X=50,Y=12;
L1:
    {  char * sub;
       char tabf[20];
       char strmen[]="\030"
       " Add to batch file      "
       " Itmx1  = YYY1          " 
       " Ncall1 = XXX1          "
       " Itmx2 =  YYY2          "
       " Ncall2 = XXX2          "
       " ---------------------  "
       " Table size =  TTT      "
       "#Tab. param.= SQRTS     " 
       " Min. val= XXXMIN       " 
       " Max. val= XXXMAX       ";
              
       improveStr(strmen,"XXX1","%ld",batch_1.ncall1);
       improveStr(strmen,"YYY1","%ld",batch_1.it1);
       improveStr(strmen,"YYY2","%ld",batch_1.it2);
       improveStr(strmen,"XXX2","%ld",batch_1.ncall2);   
       improveStr(strmen,"TTT","%ld",batch_1.nsize);
       sub=strstr(strmen,"#");
       if (batch_1.nsize<=1)   sub[0]=0; 
       else
       {  sub[0]=' ';
          vinf_(batch_1.numpar, tabf, NULL);
          improveStr(strmen,"SQRTS","%-8.8s",tabf);                          
          improveStr(strmen,"XXXMIN","%.3lg",batch_1.pmin);
          improveStr(strmen,"XXXMAX","%.3lg",batch_1.pmax);
       } 
       menu1(54,7,"",strmen,"n_batch_*",&pscr,&mode);                                      
    }

    switch(mode)
    {  
     case 0 : return 0;
     case 1:
     { FILE * ibat;
       if( batch_1.ncall1 <=0 )    messanykey(10,10," Parameter Itmx1 is out of range $");
       else if ( batch_1.it1 <=0 ) messanykey(10,10," Parameter Ncall1 is out of range $");
       else 
       { 

           if( batch_1.it2<=0 || batch_1.ncall2<=0) 
                       { batch_1.it2=0; batch_1.ncall2=0;}            
           ibat=fopen("c_batch.dat","a"); 
	   fprintf(ibat,"|||||||| next session ||||||||\n");
	   w_sess__(ibat);
	   fclose(ibat);	   
	   put_text(&pscr);
	   return 0;	
       }   
     }
     break;        
     case 3 : correctLong(X,Y,"Enter new value ",&batch_1.ncall1,1); break;                                      
     case 2 : correctLong(X,Y,"Enter new value ",&batch_1.it1,1);    break;
     case 4 : correctLong(X,Y,"Enter new value ",&batch_1.it2,1);    break;
     case 5 : correctLong(X,Y,"Enter new value ",&batch_1.ncall2,1); break;
     case 6 : break;
     case 7 : if ( nin_ != 1 || nvar_ != 0)      
              correctLong(X,Y,"Enter new value ",&batch_1.nsize,1);  break;
     case 8 : 
     {   
         int newparam = selectParam(54,10,nin_==2,0,"");
         if (newparam>=0)  batch_1.numpar=newparam;
	 break;
     }
     case 9 : correctDouble (X,Y,"Enter new value ",&batch_1.pmin,1); break;
     case 10:  correctDouble (X,Y,"Enter new value ",&batch_1.pmax,1); break;
   } 
    goto L1;
} /* b_add__ */


 int b_wrt__(FILE * mode)
{ 
    fprintf(mode," ===== BATCH PARAMETERS =====\n");
    fprintf(mode,"%d %d %d %d\n", batch_1.ncall1, batch_1.it1,
                                  batch_1.ncall2, batch_1.it2 );

    fprintf(mode,"%d %d %f %f\n",batch_1.nsize, batch_1.numpar,batch_1.pmin,
            batch_1.pmax);
    return 0;
    }

 int b_rd__(FILE *mode)
{  
    char cc[100];
    fscanf(mode,"%*c%*[^\n]");
    fscanf(mode,"%ld %ld %ld %ld", &batch_1.ncall1, &batch_1.it1,
                                   &batch_1.ncall2, &batch_1.it2 );

    fscanf(mode,"%ld %ld %lf %lf",&batch_1.nsize, &batch_1.numpar,
    &batch_1.pmin, &batch_1.pmax);
    fgets(cc,90,mode);
    return 0;
}


void mc_batch(FILE * ibat) 
{
  char batchStr[100];  
  char message[100];
  int n;
  
  while(fscanf(ibat,"%*[^\n]")      !=EOF) 
  {  
    { int memSes=nSess; r_sess__(ibat); nSess=memSes;}

    mcintr_1.itmx0=batch_1.it1;
    mcintr_1.ncall0=batch_1.ncall1;
    
    mcintr_1.wrtEvnt = (batch_1.it2==0); 

    sprintf(batchStr,"}");

    if (batch_1.it2) sprintf(batchStr+strlen(batchStr),"]}%d}]}%d}]}[[[}",
           batch_1.it2,batch_1.ncall2);
    strcat(batchStr,"{");


/*    fprintf(stderr,"%s\n",batchStr); */
     
    if (batch_1.nsize <= 1)
    {   inkeyString = batchStr;   
         fprintf(stderr,"%s\n",inkeyString);
         runbas_(message);
    }else   
    { 
       FILE * tabfile; 
       char fname[100];
       char tabf[20];
       double tabParam;
       char valName[25];

       sprintf(fname,"c_tab_%d_%d",nSess,nSess + batch_1.nsize - 1);
       tabfile=fopen(fname,"w");

       if (nin_ == 2) strcpy(valName, " Cross section [pb] ");
              else    strcpy(valName, "  Width     [Gev]   ");                      
       vinf_(batch_1.numpar, tabf, &tabParam);
       fprintf(tabfile,"  %7.7s  %20.20s  Error %%     nCall   CHI**2/IT \n",tabf,valName);

       for( n=1;n<=batch_1.nsize;n++)
       { 
          double tabParam_= 
             (batch_1.pmin*(batch_1.nsize-n)+batch_1.pmax*(n-1))/(batch_1.nsize-1); 
   
          asgn_(batch_1.numpar,tabParam_);       
          inkeyString = batchStr;
          runbas_(message);
          fprintf(tabfile," %f %s\n", tabParam_, message + 4); 


          fflush(tabfile);       
       }
       asgn_(batch_1.numpar,tabParam);
       fclose(tabfile); 
    }     
  }
  w_sess__(NULL);
  printf("End of batch calculation.\n");
  return ;     
}
