/*
 Copyright (C) 1997, Alexander Pukhov, e-mail pukhov@theory.npi.msu.su
*/


#include "tptcmac.h" 

#include "crt_util.h"
#include "runbas.h"
#include "alphas2.h"
#include "batch.h"
#include "kininpt.h"
#include "menu.h"
#include "out_ext.h"
#include "cut.h"
#include "regul.h"
#include "edittab.h"
#include "mc_menu.h"
#include "rw_sess.h"
#include "strfun.h"
#include "cs_22.h"

#include"subproc.h"
#include"n_comphep_.h"

static int sub_men__(void)
{
    /* System generated locals */
    char ch__1[10];

    /* Local variables */
    static long n;
    static long npr;

    int mode;
    char * strmen;
    void * pscr = NULL;
    int width,width_;
 
    mode=1;
    if (nprc_ > 1)
    {
       width=0;
       for(npr = 1; npr <= nprc_; ++npr)
       for(n=1;n<=nin_+nout_;n++) 
       {  pinf_(npr, n,ch__1,NULL );
          width=MAX(width,strlen(ch__1));
       }
       width++;
       width_=6+width*(nin_+nout_);
          
       strmen=malloc(2+nprc_*width_);
 
       for(n=1;n<=width_*nprc_;n++) strmen[n]=' ';
       strmen[0]= width_;
       strmen[1+nprc_*width_]=0;

       for(npr = 1; npr <= nprc_; ++npr)
       { 
         for(n=1;n<=nin_;n++) 
         { pinf_(npr, n,ch__1,NULL );
           memcpy(strmen+(npr-1)*width_+2+(n-1)*width ,ch__1,strlen(ch__1));
         }                

         memcpy(strmen+(npr-1)*width_+2+(nin_)*width ," -> ",4);

         for(n=nin_+1;n<=nin_+nout_;n++) 
         { pinf_(npr, n,ch__1,NULL );
           memcpy(strmen+(npr-1)*width_+6+(n-1)*width ,ch__1,strlen(ch__1));
         }                
       }         
       menu1(54,4,"Subprocesses",strmen,NULL,&pscr,&mode);
       if (mode !=0) put_text(&pscr);
       free(strmen);
    }   
    if (mode != 0) 
    {
       proces_1.nsub = mode;
       wrtprc_();
/*       dummy = strfun_(0, 1.); */
    } 
    return mode;
} /* sub_men__ */




static  int w_men__(void)
{
    int key =1;
    void * pscr=NULL;     
L1:
   {
      char strmen[] ="\030"
                      " Gauge invariance  XXX  "
                      " S-dependence      YYY  ";   

      if(gwidth) improveStr(strmen,"XXX","ON");
                   else improveStr(strmen,"XXX","OFF");
                          
      if(rwidth) improveStr(strmen,"YYY","ON");
                   else improveStr(strmen,"YYY","OFF");

      menu1(54,6,"",strmen,"n_width_*",&pscr ,&key);
   }    
   
   switch(key)
   { case 0:  return 0; break; 
     case 1:  gwidth = ! gwidth; break;
     case 2:  rwidth = ! rwidth; 
   }    
    goto L1;
} /* w_men__ */


static void prn_session_number(void)
{
   scrcolor(Red,BGmain);
   goto_xy(4,10); print("Monte Carlo session: ");
   if(!interpret)  {scrcolor(Black,BGmain);  print("%d",nSess);}
}


void monte_carlo_menu(void)
{
   int mode=1;
   void * pscr=NULL;
   void * pscr_mem=NULL;
   char   message[100];
   char menutxt[]="\030"
                  " Subprocess             "
                  " IN state               "
                  " Model parameters       "
                  " QCD scale              " 
                  " Breit-Wigner           "
	          " Cuts                   " 
                  " Kinematics             "
                  " Regularization         "
                  " Vegas                  "
                  " Simpson                "            
                  " Batch                  ";
 
   if(interpret) menutxt[menutxt[0]*10+1]=0; 
 
   get_text(1,10,80,24,&pscr_mem);

   prn_session_number();    
   while(1)
   {  
       goto_xy(4,3); clr_eol();
       scrcolor(Red,BGmain);    print("(sub)Process: ");
       scrcolor(Black,BGmain); print(proces_1.proces);
                   
       menu1(54,4,"",menutxt,"n_mc_*",&pscr, &mode);
       switch (mode)
       {
        case  0:  put_text(&pscr_mem); return;
        case  1:  sub_men__(); break;
        case  2:  if (nin_ == 2) in_set__(); break;
        case  3:  change_parameter(54,7);  break;
        case  7:  entkin_();      break;
        case  6:  do edittable(1,4,&cutTab,1,"n_cut",0);while (fillCutArray()); 
                  break;                   
        case  8:  do edittable(1,4,&regTab,1,"n_reg",0); while(fillRegArray());
                  break;    
        case  5:  w_men__();      break;
        case  4:  qcdmen_();      break;
        case  9:  if(runbas_(message))
                  {  strcat(message,"$");
                     messanykey(15,15,message);
                  } 
                  prn_session_number(); 
                  break;
        case 10:  if(nin_==2&&nout_==2) 
                  {
                     if(cs_numcalc(message))
                     {
                        strcat(message,"$");
                        messanykey(15,15,message);
                     }                     
                  }
                  else  messanykey(15,15," Only for 2->2 processes$");
                  break;                   
        case 11:  b_add__();      break;        
      }
   }
}

