/*
 Copyright (C) 1997, Slava Ilyin
*/
#include "out_ext.h"
#include "tptcmac.h"
#include"f_c.h"

#include"batch.h"
#include"cut.h"
#include"kinaux.h"
#include"kininpt.h"

#include"regul.h"
#include"rw_sess.h"
#include"alphas2.h"
#include"out_ext.h"
#include"histogram.h"
#include"crt_util.h"
#include"n_comphep_.h"


#include "out_ext.h"

#include"strfun.h"

#include"subproc.h"
#include"runbas.h"



/* Table of constant values */


/* ######################################### */
/* #   Write-Read  procedures              # */
/* #                                       # */
/* #   contents:                           # */
/* ######################################### */
/* *************************************** */
/* *  read-write the number of session *** */
/* *************************************** */

static int wnsess_(FILE *mode)
{
   fprintf(mode,"%d  - the session number\n",nSess);
   return 0;
}

static int insess_(void) { nSess = 1; return 0;}

static int rnsess_(FILE *mode)
{
  fscanf(mode,"%d %*[^\n]",&nSess); return 0;
}

/* ******************************************** */
/*   write process string */
/* ******************************************** */
int wrtprc_(void)
{
    char buff[10];
  
    int pos=0;
    int i;
    for (i=1;i<=nin_+nout_ ;i++)
    { 
       pinf_(proces_1.nsub,i,buff,NULL);
       strcpy(proces_1.proces+pos,buff);
       pos+=strlen(buff);
       
       if (i<nin_+nout_)
       { 
          if( i==nin_) {strcpy(proces_1.proces+pos," -> "); pos+=4;}
           else          {strcpy(proces_1.proces+pos,", ");pos+=2;}
       }
    }   
    return 0;
}

static int i_prc__(void)
{  proces_1.nsub=1;
   wrtprc_();
   return 0;
}

static int w_prc__(FILE *mode)
{
  return  fprintf(mode,"%d subprocess: %s\n",proces_1.nsub,proces_1.proces);  
  return 0;
}

static int r_prc__(FILE *mode)
{  char buff[20], proc_name[100]; 
   fscanf(mode,"%d%s%*c%[^\n]",&proces_1.nsub,buff,proc_name);
   if(proces_1.nsub> nprc_) return 0;
   wrtprc_();
   if (strcmp(proc_name,proces_1.proces)==0) return 1; else return 0;
}

/* ************************************* */
/* *  read-write MC parameters       *** */
/* ************************************* */

static int w_mc__(FILE *mode)
{
  fprintf(mode,"%d - Number of calls for iteration\n",mcintr_1.ncall0);
  fprintf(mode,"%d - Number of iteraitons\n", mcintr_1.itmx0);
  fprintf(mode,"%d - Save Events \n", mcintr_1.wrtEvnt);
  return 0;
}


static int r_mc__(FILE *mode)
{
  fscanf(mode,"%ld %*[^\n]",&mcintr_1.ncall0);
  fscanf(mode,"%d %*[^\n]",&mcintr_1.itmx0);
  fscanf(mode,"%d %*[^\n]",&mcintr_1.wrtEvnt);
  return 0;
}


static int w_mdl__(FILE * mode)
{
  long i;
  double val;
  char name[10];

  fprintf(mode," Physical Parameters\n"); 
  for (i = 0; i <= nvar_; ++i) 
  {
     vinf_(i, name, &val);
     fprintf(mode,"%22.14g = %s\n",val,name);
  }
  return 0;
}

static int i_mdl__(void)
{
   return 0;
}

static int r_mdl__(FILE * mode)
{
    static double val;
    long i;
    fscanf(mode,"%*c%*[^\n]");
    for (i = 0; i <= nvar_; ++i) 
    {  fscanf(mode," %lf %*[^\n]",&val);
       asgn_(i, val);
    }
    return 0;
} 

/* ************************************* */
/* *  read-write IN-state parameters  *** */
/* ************************************* */

static int w_in__(FILE *mode)
{
   wrt_sf__(mode);
   fprintf(mode,"%lf - c.m. rapidity\n",rapidity);
   return 0;
}


static int r_in__(FILE *mode)
{
  rd_sf__(mode);
  fscanf(mode,"%lf%*[^\n]",&rapidity);
  return 0;
}





int w_sess__(FILE *mode_)
{


 FILE*mode;

 if(interpret) return 0;   
 if (mode_ == NULL)  
 {  mode=fopen("c_session.dat","w"); 
    if(mode == NULL) return 0;
 } else mode=mode_; 
 
 w_prc__(mode);
 wnsess_(mode);
 w_mc__(mode);
 w_in__(mode);
 w_mdl__(mode);
 wrtkin_(mode,nout_ - 1);
 wrtcut_(mode);
 wrtreg_(mode);
 w_qcd__(mode);
 wrt_hist(mode);
 b_wrt__(mode);

 if (mode_ == NULL) fclose(mode);

 return 0;
}    
/* *********************************************** */
/*      Read parameters from file               * */
/*                                              * */
/*   MODE = ISES   from session parameters file * */
/*   MODE = IBAT   from batch file              * */
/* *********************************************** */

int r_sess__(FILE *mode_)
{
  FILE*mode;
 if(interpret) return 0;
 /* Local variables */
 if (mode_ == NULL) 
 { 
   mode=fopen("c_session.dat","r"); 
   if (mode ==NULL) return 0;
 }else mode=mode_;
 if (!r_prc__(mode)&& mode_ == NULL) 
 {  
      fclose(mode); 
      printf("Wrong  'c_session.dat'  file.\n"
                       "Information from the file ignored.\n");
     inipar_();
     goto L1000; 
 }
 
 rnsess_(mode);
 r_mc__(mode);
 r_in__(mode);
 r_mdl__(mode);
 rdrkin_(mode);
 rdrcut_(mode);
 rdrreg_(mode);
 r_qcd__(mode);
 rdr_hist(mode);
 b_rd__(mode);
 if (mode_ == NULL) fclose(mode); 
L1000:

 return 0;
} /* r_sess__ */


void  inipar_(void)
{
 i_prc__(); /*                     from comphep output */
 insess_();
 i_mdl__();
 stdkin_();

 i_qcd();
 rapidity=0;
 rwidth=0;
 gwidth=0; 
} /* inipar_ */

void clearSession(void)
{
   cleartab(&cutTab);
   cleartab(&regTab);
   cleartab(&histTab); clearHists();
}
