/*
 Copyright (C) 1997, Alexander Pukhov, e-mail pukhov@theory.npi.msu.su
*/

#include "tptcmac.h"
#include "syst2.h"
#include "physics.h"


vcsect     vcs;

hadron     hadr1, hadr2;
whohow     inclp, liminsp;
double     sqrts, missingmass;

unsigned    subproc_f, subproc_sq;

char  modelmenu[STRSIZ];
int   maxmodel;

int nsub=1, ndiagr=0, n_model=1;

int errorcode;
 
void   addprtcl(whohow p_list,int n)
{int i;
   for (i = 0; i < whohowMAX-1; i++)
   {
      if (p_list[i].who == n) { p_list[i].how++; return; }
      if (!p_list[i].who) 
      { p_list[i].who = n;  p_list[i].how = 1; p_list[i+1].who = 0;  return; }
   }
}


void   delprtcl(whohow p_list,int n)
{int  i=1;
   while (p_list[i-1].who != 0)
   {
      if (p_list[i-1].who == n)
		{
         if (--p_list[i-1].how == 0)
         do {
               p_list[i-1].who = p_list[i].who;
               p_list[i-1].how = p_list[i].how;
					i++;
	    }  while (!(p_list[i-1].who == 0));
         return;
      }
      i++;
   } 
} 


void  nilprtcl(whohow p_list)
{int  i; 
   for (i = 0; i < whohowMAX; i++) p_list[i].who = 0; 
} 

void  addlim(whohow p_list,int j,int k)
{int i; 

   if (prtclbase[j-1].anti < j) j = prtclbase[j-1].anti; 
   for (i = 0; i < whohowMAX-1; i++) 
   { 
      if (p_list[i].who == j) return;
      if (p_list[i].who == 0) 
      {  p_list[i].who = j; 
         p_list[i].how = k; 
         p_list[i+1].who = 0; 
         return;
      } 
   } 
} 

int  inhadr(hadron* hadr,int np)
{int   i; 
   for (i = 1; i <= hadr->how; i++) 
   if (hadr->parton[i-1] == np) 
      return TRUE; 
   return FALSE; 
} 


void  getprtcls(char* txt1,prtclsarray pnames)
{int   ps, j; 
 char   txt[STRSIZ],pnametmp[STRSIZ]; 

   strcpy(txt,txt1);
   ps = spos("->",txt); 
   txt[ps-1] = ','; 
   txt[ps + 1-1] = ' '; 
   sbld(txt," %s",txt); 
   for (j = nin + nout + 1; j <= MAXINOUT; j++) 
      strcpy(pnames[j-1],"***"); 
   j = 1; 
   do 
   { 
      ps = cpos(',',txt); 
      if (ps == 0) 
      { 
         trim(txt); 
         strncpy(pnames[j-1],txt,3);
         pnames[j-1][3] = '\0'; 
         return;
      } 
      strcpy(pnametmp,copy(txt,1,ps - 1)); 
      strcpy(txt,copy(txt,ps + 1,(int)strlen(txt) - ps)); 
      trim(pnametmp); 
      strncpy(pnames[j-1],pnametmp,3); 
      pnames[j-1][3] = '\0'; 
      ++(j); 
   }  while (TRUE); 
} 

