*###################################################
*#            Menu's                               #
*#   contents:                                     #
*#      IN_SET(2), MDLSET(3), MC_SET(6)            #
*#      BATCH(8), VIEWF(9), EVNMEN(11) #
*###################################################

*********************************************
*    IN states menu                         *
*********************************************
      SUBROUTINE IN_SET
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
      CHARACTER PROCES*30
      CHARACTER STRMEN*300,DOLL*2
      CHARACTER DCH*12,RCH*12,XFMT*10,DCD*10
      COMMON /DOLL/   DOLL
      COMMON /PROCES/ NSUB,PROCES
      COMMON /SQS/    SQRTS,RAPID
      COMMON /NSESS/  NSESS
      CHARACTER*60 SF_TXT(2)
      COMMON /SF_TXT/ SF_TXT
      COMMON /SF_MASS/SF_MASS(2)
      REAL*4 QMASS
      EQUIVALENCE(QMASS,DMASS)
      DIMENSION PMASS(2)

      DO 5 NPART=1,2
      IF(SF_TXT(NPART).EQ.'OFF') THEN 
         CALL PMAS(NSUB,NPART,QMASS)
         IF(LENR().EQ.16) THEN
            PMASS(NPART)=QMASS
         ELSE
            PMASS(NPART)=DMASS
         ENDIF
      ELSE
         PMASS(NPART)=SF_MASS(NPART)
      ENDIF
5     CONTINUE


      E1=(SQRTS**2 + PMASS(1)**2 - PMASS(2)**2)/(2*SQRTS)
      E2=(SQRTS**2 + PMASS(2)**2 - PMASS(1)**2)/(2*SQRTS)
      P1=sqrt(E1**2-PMASS(1)**2)
      P2=sqrt(E2**2-PMASS(2)**2)

      P1=P1*COSH(RAPID)+E1*SINH(RAPID)
      P2=P2*COSH(RAPID)-E2*SINH(RAPID)

      CALL ITOCHR(DCD,NSESS)
***   menu loop
10    CALL CLRSCR  
      NS=1
            
      CALL DTOCHR(DCH,P1,4)
      CALL DTOCHR(RCH,P2,4)
      STRMEN = '%IN states menu! !'//
     &         PROCES//'                  Session # '//DCD//'!%'//
     &         'S.F.1= '//SF_TXT(1)//' !'//
     &         'S.F.2= '//SF_TXT(2)//'!'//
     &         'P1(GeV) = '//DCH//'!'//
     &         'P2(GeV) = '//RCH//'!'// 
     &         '!!'

      MODE=MENU(STRMEN,'n_in_')

      IF (MODE .EQ. 0) THEN
         IF(PMASS(1).EQ.0 .AND. P1.LE.0) THEN
           WRITE(*,*) 'Error. P1 must be more than zero.'
         ELSE IF(PMASS(2).EQ.0 .AND. P2.LE.0) THEN   
           WRITE(*,*) 'Error. P2 must be more than zero.'
         ELSE 
           E1=SQRT(P1**2+PMASS(1)**2)
           E2=SQRT(P2**2+PMASS(2)**2) 
           SQRTS=SQRT((E1+E2)**2 -(P1-P2)**2)
           RAPID=(P1-P2)/(E1+E2)
           RAPID=LOG((1+RAPID)/(1-RAPID))/2
           RETURN
         ENDIF
      ELSE IF (MODE .LE. 2) THEN 
          CALL SF_MENU(MODE)
      ELSE IF (MODE .EQ. 3) THEN
          XFMT='(1X,A35'//DOLL//')'
12        WRITE(*,FMT=XFMT) 'Enter new P1 (GeV): '
          READ(*,FMT='(G12.0)',ERR=12) P1
      ELSE IF (MODE .EQ. 4) THEN
          XFMT='(1X,A35'//DOLL//')'
13        WRITE(*,FMT=XFMT) 'Enter new  P2 (GeV) : '
          READ(*,FMT='(G12.0)',ERR=13) P2
      ENDIF
      GO TO 10

      END

**************************************************
* Physics model parameters menu                  *
**************************************************
      SUBROUTINE MDLSET
      IMPLICIT REAL*8 (A-H,O-Z), INTEGER (I-N)
      CHARACTER        NAME*6
      CHARACTER        STRMEN*5000,XSTRM*5000,DOLL*2
      CHARACTER        DCH1*13,XFMT*40,DCH*10
      COMMON /DOLL/    DOLL
      CHARACTER*30 PROCES
      COMMON /PROCES/  NSUB,PROCES
      COMMON /NSESS/   NSESS

      CALL ITOCHR(DCH,NSESS)

***  menu loop
10    CALL CLRSCR  
      XSTRM='!!'
      DO 20 K=0,NVAR()-1
        CALL VINF(NVAR()-K,NAME,VALUE)
        CALL DTOCHR(DCH1,VALUE,6)
        STRMEN=NAME//'= '//DCH1//'!'//XSTRM
        XSTRM=STRMEN
20    CONTINUE
      STRMEN = ' !'//PROCES//'            Session # '//DCH//'!%'//XSTRM
      XSTRM=STRMEN
      STRMEN = '%Physical model parameters menu!'//XSTRM

      K=MENU(STRMEN,'n_param')
      IF (K .EQ. 0) GOTO 1000
      IF (K .LE. NVAR()) THEN
             CALL VINF(K,NAME,VAL)
             XFMT='(1X,A17'//DOLL//')'
30           WRITE(*,FMT=XFMT) 'Enter new value: '
             READ(*,FMT='(G15.0)',ERR=30) VAL
             CALL ASGN(K,VAL)
      ENDIF
      GOTO 10

1000  CONTINUE

      RETURN
      END

*********************************************
*    View files menu                        *
*********************************************
      SUBROUTINE VIEWF
      CHARACTER DOLL*2
      COMMON /DOLL/    DOLL
      COMMON /NSESS/   NSESS
      CHARACTER*30 F_NAME,SESSTR

10    CALL CLRSCR
      IF( NSESS.EQ.1) THEN
         WRITE(*,*) ' Results are not produced  ,press ENTER '
         READ(*,*)
         RETURN
      ELSE
        WRITE(*,FMT='(1x,'' Enter a session number ( 1 - '','//
     &'I3,'') to view   or 0 to exit'')') NSESS-1 
        READ(*,FMT='(I3)', ERR=10) INSESS
        IF (INSESS.EQ.0 ) RETURN
        CALL ITOCHR(SESSTR,INSESS)
         CALL CH2CAT(F_NAME,'f_prt_',SESSTR)                    
         CALL VIEWRP(F_NAME)
        GOTO 10
      ENDIF
      END
